Index: palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4645)
+++ palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4646)
@@ -301,49 +318,51 @@
     REAL(wp) ::  total_area                          !< [m2] area of all surfaces pointing to zone
     REAL(wp) ::  window_area_per_facade              !< [m2] window area per facade element
-    
-    REAL(wp), PARAMETER ::  h_is                     = 3.45_wp     !< [W/(m2 K)] surface-related heat transfer coefficient between
-                                                                   !< surface and air (chap. 7.2.2.2)
-    REAL(wp), PARAMETER ::  h_ms                     = 9.1_wp      !< [W/(m2 K)] surface-related heat transfer coefficient between component and surface (chap. 12.2.2)
-    REAL(wp), PARAMETER ::  params_f_f               = 0.3_wp      !< [-] frame ratio chap. 8.3.2.1.1 for buildings with mostly cooling 2.0_wp
-    REAL(wp), PARAMETER ::  params_f_w               = 0.9_wp      !< [-] correction factor (fuer nicht senkrechten Stahlungseinfall
-                                                                   !< DIN 4108-2 chap.8, (hier konstant, keine WinkelabhÃ€ngigkeit) 
-    REAL(wp), PARAMETER ::  params_f_win             = 0.5_wp      !< [-] proportion of window area, Database A_win aus 
-                                                                   !< Datenbank 27 window_area_per_facade_percent
-    REAL(wp), PARAMETER ::  params_solar_protection  = 300.0_wp    !< [W/m2] chap. G.5.3.1 sun protection closed, if the radiation 
-                                                                   !< on facade exceeds this value
+
 !
 !-- Definition of seasonal parameters, summer and winter, for different building types
-    REAL(wp), DIMENSION(0:1,1:7) ::  summer_pars = RESHAPE( (/               & ! building_type 1
-                                          0.5_wp,                              & ! basical airflow without occupancy of the room
-                                          2.0_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.5_wp,                              & ! building_type 2: basical airflow without occupancy of the room
-                                          2.0_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.8_wp,                              & ! building_type 3: basical airflow without occupancy of the room
-                                          2.0_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                              & ! building_type 4: basical airflow without occupancy of the room
-                                          1.5_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                              & ! building_type 5: basical airflow without occupancy of the room
-                                          1.5_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                              & ! building_type 6: basical airflow without occupancy of the room
-                                          1.5_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                              & ! building_type 7: basical airflow without occupancy of the room
-                                          1.5_wp                               & ! additional airflow depend of occupancy of the room
+    REAL(wp), DIMENSION(0:1,1:7) ::  summer_pars = RESHAPE( (/                & ! building_type 1
+                                          0.5_wp,                             & ! basical airflow without occupancy of the room
+                                          2.0_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.5_wp,                             & ! building_type 2: basical airflow without occupancy
+                                                                                ! of the room
+                                          2.0_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.8_wp,                             & ! building_type 3: basical airflow without occupancy
+                                                                                ! of the room
+                                          2.0_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.1_wp,                             & ! building_type 4: basical airflow without occupancy
+                                                                                ! of the room
+                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.1_wp,                             & ! building_type 5: basical airflow without occupancy
+                                                                                ! of the room
+                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.1_wp,                             & ! building_type 6: basical airflow without occupancy
+                                                                                ! of the room
+                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.1_wp,                             & ! building_type 7: basical airflow without occupancy
+                                                                                ! of the room
+                                          1.5_wp                              & ! additional airflow depend of occupancy of the room
                                                            /), (/ 2, 7 /) )
 
-    REAL(wp), DIMENSION(0:1,1:7) ::  winter_pars = RESHAPE( (/               & ! building_type 1
-                                          0.1_wp,                              & ! basical airflow without occupancy of the room
-                                          0.5_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                              & ! building_type 2: basical airflow without occupancy of the room
-                                          0.5_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                              & ! building_type 3: basical airflow without occupancy of the room
-                                          0.5_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                              & ! building_type 4: basical airflow without occupancy of the room
-                                          1.5_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                              & ! building_type 5: basical airflow without occupancy of the room
-                                          1.5_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                              & ! building_type 6: basical airflow without occupancy of the room
-                                          1.5_wp,                              & ! additional airflow depend of occupancy of the room
-                                          0.1_wp,                              & ! building_type 7: basical airflow without occupancy of the room
-                                          1.5_wp                               & ! additional airflow depend of occupancy of the room
+    REAL(wp), DIMENSION(0:1,1:7) ::  winter_pars = RESHAPE( (/                & ! building_type 1
+                                          0.1_wp,                             & ! basical airflow without occupancy of the room
+                                          0.5_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.1_wp,                             & ! building_type 2: basical airflow without occupancy
+                                                                                ! of the room
+                                          0.5_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.1_wp,                             & ! building_type 3: basical airflow without occupancy
+                                                                                ! of the room
+                                          0.5_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.1_wp,                             & ! building_type 4: basical airflow without occupancy
+                                                                                ! of the room
+                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.1_wp,                             & ! building_type 5: basical airflow without occupancy
+                                                                                ! of the room
+                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.1_wp,                             & ! building_type 6: basical airflow without occupancy
+                                                                                ! of the room
+                                          1.5_wp,                             & ! additional airflow depend of occupancy of the room
+                                          0.1_wp,                             & ! building_type 7: basical airflow without occupancy
+                                                                                ! of the room
+                                          1.5_wp                              & ! additional airflow depend of occupancy of the room
                                                            /), (/ 2, 7 /) )
 
@@ -352,10 +371,10 @@
 
     PRIVATE
-    
+
 !
 !-- Add INTERFACES that must be available to other modules
-    PUBLIC im_init, im_main_heatcool, im_parin, im_define_netcdf_grid,          &
-           im_check_data_output, im_data_output_3d, im_check_parameters
-    
+    PUBLIC im_init, im_main_heatcool, im_parin, im_define_netcdf_grid, im_check_data_output,       &
+           im_data_output_3d, im_check_parameters
+
 
 !
@@ -385,5 +404,5 @@
         MODULE PROCEDURE im_define_netcdf_grid
      END INTERFACE im_define_netcdf_grid
-! 
+!
 ! !
 ! !-- Output of information to the header file
@@ -392,15 +411,15 @@
 !     END INTERFACE im_header
 !
-!-- Calculations for indoor temperatures  
+!-- Calculations for indoor temperatures
     INTERFACE im_calc_temperatures
        MODULE PROCEDURE im_calc_temperatures
     END INTERFACE im_calc_temperatures
 !
-!-- Initialization actions  
+!-- Initialization actions
     INTERFACE im_init
        MODULE PROCEDURE im_init
     END INTERFACE im_init
 !
-!-- Main part of indoor model  
+!-- Main part of indoor model
     INTERFACE im_main_heatcool
        MODULE PROCEDURE im_main_heatcool
@@ -414,12 +433,12 @@
  CONTAINS
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!< Calculation of the air temperatures and mean radiation temperature
-!< This is basis for the operative temperature
-!< Based on a Crank-Nicholson scheme with a timestep of a hour
-!------------------------------------------------------------------------------!
- SUBROUTINE im_calc_temperatures ( i, j, k, indoor_wall_window_temperature,    &
+!< Calculation of the air temperatures and mean radiation temperature.
+!< This is basis for the operative temperature.
+!< Based on a Crank-Nicholson scheme with a timestep of a hour.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE im_calc_temperatures ( i, j, k, indoor_wall_window_temperature,                        &
                                    near_facade_temperature, phi_hc_nd_dummy )
 
@@ -427,5 +446,5 @@
     INTEGER(iwp) ::  j
     INTEGER(iwp) ::  k
-    
+
     REAL(wp) ::  indoor_wall_window_temperature  !< weighted temperature of innermost wall/window layer
     REAL(wp) ::  near_facade_temperature
@@ -433,45 +452,46 @@
 !
 !-- Calculation of total mass specific thermal load (internal and external)
-    phi_mtot = ( phi_m + h_t_wm * indoor_wall_window_temperature               &
-                       + h_t_3  * ( phi_st + h_t_es * pt(k,j,i)                &
-                                            + h_t_1 *                          &
-                                    ( ( ( phi_ia + phi_hc_nd_dummy ) / h_v )   &
-                                                 + near_facade_temperature )   &
-                                   ) / h_t_2                                   &
+    phi_mtot = ( phi_m + h_t_wm * indoor_wall_window_temperature                                   &
+                       + h_t_3  * ( phi_st + h_t_es * pt(k,j,i)                                    &
+                                            + h_t_1 *                                              &
+                                    ( ( ( phi_ia + phi_hc_nd_dummy ) / h_v )                       &
+                                                 + near_facade_temperature )                       &
+                                  ) / h_t_2                                                        &
                )                                                                !< [degree_C] Eq. (C.5)
-! 
+!
 !-- Calculation of component temperature at factual timestep
-    theta_m_t = ( ( theta_m_t_prev                                             &
-                    * ( ( c_m / 3600.0_wp ) - 0.5_wp * ( h_t_3 + h_t_wm ) )    &
-                     + phi_mtot                                                &
-                  )                                                            &
-                  /   ( ( c_m / 3600.0_wp ) + 0.5_wp * ( h_t_3 + h_t_wm ) )    &
+    theta_m_t = ( ( theta_m_t_prev                                                                 &
+                    * ( ( c_m / 3600.0_wp ) - 0.5_wp * ( h_t_3 + h_t_wm ) )                        &
+                     + phi_mtot                                                                    &
+                  )                                                                                &
+                  /   ( ( c_m / 3600.0_wp ) + 0.5_wp * ( h_t_3 + h_t_wm ) )                        &
                 )                                                               !< [degree_C] Eq. (C.4)
 !
 !-- Calculation of mean inner temperature for the RC-node in actual timestep
     theta_m = ( theta_m_t + theta_m_t_prev ) * 0.5_wp                           !< [degree_C] Eq. (C.9)
-    
+
 !
 !-- Calculation of mean surface temperature of the RC-node in actual timestep
-    theta_s = ( (   h_t_ms * theta_m + phi_st + h_t_es * pt(k,j,i)             &
-                  + h_t_1  * ( near_facade_temperature                         &
-                           + ( phi_ia + phi_hc_nd_dummy ) / h_v )              &
-                )                                                              &
-                / ( h_t_ms + h_t_es + h_t_1 )                                  &
+    theta_s = ( (   h_t_ms * theta_m + phi_st + h_t_es * pt(k,j,i)                                 &
+                  + h_t_1  * ( near_facade_temperature                                             &
+                           + ( phi_ia + phi_hc_nd_dummy ) / h_v )                                  &
+                )                                                                                  &
+                / ( h_t_ms + h_t_es + h_t_1 )                                                      &
               )                                                                 !< [degree_C] Eq. (C.10)
-    
+
 !
 !-- Calculation of the air temperature of the RC-node
-    theta_air = ( h_t_is * theta_s + h_v * near_facade_temperature             &
-                + phi_ia + phi_hc_nd_dummy ) / ( h_t_is + h_v )                 !< [degree_C] Eq. (C.11)
+    theta_air = ( h_t_is * theta_s + h_v * near_facade_temperature + phi_ia + phi_hc_nd_dummy ) /  &
+                ( h_t_is + h_v )                                                !< [degree_C] Eq. (C.11)
 
  END SUBROUTINE im_calc_temperatures
 
-!------------------------------------------------------------------------------!
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Initialization of the indoor model.
-!> Static information are calculated here, e.g. building parameters and
-!> geometrical information, everything that doesn't change in time.
+!> Static information are calculated here, e.g. building parameters and geometrical information,
+!> anything that doesn't change in time.
 !
 !-- Input values
@@ -480,25 +500,26 @@
 !     theta_e              -->  pt(k,j,i)                         !< undisturbed outside temperature, 1. PALM volume, for windows
 !     theta_sup = theta_f  -->  surf_usm_h%pt_10cm(m)
-!                               surf_usm_v(l)%pt_10cm(m)          !< Air temperature, facade near (10cm) air temperature from 1. Palm volume
+!                               surf_usm_v(l)%pt_10cm(m)          !< Air temperature, facade near (10cm) air temperature from
+                                                                  !< 1. Palm volume
 !     theta_node           -->  t_wall_h(nzt_wall,m)
 !                               t_wall_v(l)%t(nzt_wall,m)         !< Temperature of innermost wall layer, for opaque wall
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE im_init
 
-    USE control_parameters,                                                    &
+    USE control_parameters,                                                                        &
         ONLY:  message_string, time_since_reference_point
 
-    USE indices,                                                               &
+    USE indices,                                                                                   &
         ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_total_0
 
-    USE grid_variables,                                                        &
+    USE grid_variables,                                                                            &
         ONLY:  dx, dy
 
     USE pegrid
 
-    USE surface_mod,                                                           &
+    USE surface_mod,                                                                               &
         ONLY:  surf_usm_h, surf_usm_v
-        
-    USE urban_surface_mod,                                                     &
+
+    USE urban_surface_mod,                                                                         &
         ONLY:  building_pars, building_type
 
@@ -514,6 +535,6 @@
 
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids           !< building IDs on entire model domain
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_final     !< building IDs on entire model domain, 
-                                                                    !< multiple occurences are sorted out 
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_final     !< building IDs on entire model domain,
+                                                                    !< multiple occurences are sorted out
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_final_tmp !< temporary array used for resizing
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_l         !< building IDs on local subdomain
@@ -523,14 +544,14 @@
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k_min_l             !< lowest vertical index of a building on subdomain
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  n_fa                !< counting array
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  num_facades_h       !< dummy array used for summing-up total number of 
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  num_facades_h       !< dummy array used for summing-up total number of
                                                                     !< horizontal facade elements
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  num_facades_v       !< dummy array used for summing-up total number of 
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  num_facades_v       !< dummy array used for summing-up total number of
                                                                     !< vertical facade elements
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  receive_dum_h       !< dummy array used for MPI_ALLREDUCE  
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  receive_dum_v       !< dummy array used for MPI_ALLREDUCE  
-    
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  receive_dum_h       !< dummy array used for MPI_ALLREDUCE
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  receive_dum_v       !< dummy array used for MPI_ALLREDUCE
+
     INTEGER(iwp), DIMENSION(0:numprocs-1) ::  num_buildings         !< number of buildings with different ID on entire model domain
     INTEGER(iwp), DIMENSION(0:numprocs-1) ::  num_buildings_l       !< number of buildings with different ID on local subdomain
-                                                              
+
     REAL(wp) ::  u_tmp                                     !< dummy for temporary calculation of u-value without h_is
     REAL(wp) ::  du_tmp                                    !< 1/u_tmp
@@ -544,6 +565,5 @@
     CALL location_message( 'initializing indoor model', 'start' )
 !
-!-- Initializing of indoor model is only possible if buildings can be 
-!-- distinguished by their IDs.
+!-- Initializing of indoor model is only possible if buildings can be distinguished by their IDs.
     IF ( .NOT. building_id_f%from_file )  THEN
        message_string = 'Indoor model requires information about building_id'
@@ -559,5 +579,5 @@
           IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
              IF ( num_buildings_l(myid) > 0 )  THEN
-                IF ( ANY( building_id_f%var(j,i) .EQ.  build_ids_l ) )  THEN 
+                IF ( ANY( building_id_f%var(j,i) == build_ids_l ) )  THEN
                    CYCLE
                 ELSE
@@ -569,12 +589,12 @@
                    DEALLOCATE( build_ids_l )
                    ALLOCATE( build_ids_l(1:num_buildings_l(myid)) )
-                   build_ids_l(1:num_buildings_l(myid)-1) =                 &
-                               build_ids_l_tmp(1:num_buildings_l(myid)-1)
+                   build_ids_l(1:num_buildings_l(myid)-1) =                                        &
+                                                          build_ids_l_tmp(1:num_buildings_l(myid)-1)
                    build_ids_l(num_buildings_l(myid)) = building_id_f%var(j,i)
                    DEALLOCATE( build_ids_l_tmp )
                 ENDIF
 !
-!--          First occuring building id on PE 
-             ELSE 
+!--          First occuring building id on PE
+             ELSE
                 num_buildings_l(myid) = num_buildings_l(myid) + 1
                 build_ids_l(1) = building_id_f%var(j,i)
@@ -584,10 +604,9 @@
     ENDDO
 !
-!-- Determine number of building IDs for the entire domain. (Note, building IDs
-!-- can appear multiple times as buildings might be distributed over several
-!-- PEs.) 
-#if defined( __parallel ) 
-    CALL MPI_ALLREDUCE( num_buildings_l, num_buildings, numprocs,              &
-                        MPI_INTEGER, MPI_SUM, comm2d, ierr ) 
+!-- Determine number of building IDs for the entire domain. (Note, building IDs can appear multiple
+!-- times as buildings might be distributed over several PEs.)
+#if defined( __parallel )
+    CALL MPI_ALLREDUCE( num_buildings_l, num_buildings, numprocs, MPI_INTEGER, MPI_SUM, comm2d,    &
+                        ierr )
 #else
     num_buildings = num_buildings_l
@@ -595,6 +614,6 @@
     ALLOCATE( build_ids(1:SUM(num_buildings)) )
 !
-!-- Gather building IDs. Therefore, first, determine displacements used 
-!-- required for MPI_GATHERV call.
+!-- Gather building IDs. Therefore, first, determine displacements used required for MPI_GATHERV
+!-- call.
     ALLOCATE( displace_dum(0:numprocs-1) )
     displace_dum(0) = 0
@@ -603,13 +622,13 @@
     ENDDO
 
-#if defined( __parallel ) 
-    CALL MPI_ALLGATHERV( build_ids_l(1:num_buildings_l(myid)),                 &
-                         num_buildings(myid),                                  &
-                         MPI_INTEGER,                                          &
-                         build_ids,                                            &
-                         num_buildings,                                        &
-                         displace_dum,                                         & 
-                         MPI_INTEGER,                                          &
-                         comm2d, ierr )   
+#if defined( __parallel )
+    CALL MPI_ALLGATHERV( build_ids_l(1:num_buildings_l(myid)),                                     &
+                         num_buildings(myid),                                                      &
+                         MPI_INTEGER,                                                              &
+                         build_ids,                                                                &
+                         num_buildings,                                                            &
+                         displace_dum,                                                             &
+                         MPI_INTEGER,                                                              &
+                         comm2d, ierr )
 
     DEALLOCATE( displace_dum )
@@ -619,7 +638,6 @@
 #endif
 !
-!-- Note: in parallel mode, building IDs can occur mutliple times, as 
-!-- each PE has send its own ids. Therefore, sort out building IDs which 
-!-- appear multiple times. 
+!-- Note: in parallel mode, building IDs can occur mutliple times, as each PE has send its own ids.
+!-- Therefore, sort out building IDs which appear multiple times.
     num_build = 0
     DO  n = 1, SIZE(build_ids)
@@ -639,5 +657,5 @@
              build_ids_final(num_build) = build_ids(n)
              DEALLOCATE( build_ids_final_tmp )
-          ENDIF             
+          ENDIF
        ELSE
           num_build = num_build + 1
@@ -648,34 +666,31 @@
 
 !
-!-- Allocate building-data structure array. Note, this is a global array
-!-- and all building IDs on domain are known by each PE. Further attributes, 
-!-- e.g. height-dependent arrays, however, are only allocated on PEs where 
-!-- the respective building is present (in order to reduce memory demands).
+!-- Allocate building-data structure array. Note, this is a global array and all building IDs on
+!-- domain are known by each PE. Further attributes, e.g. height-dependent arrays, however, are only
+!-- allocated on PEs where  the respective building is present (in order to reduce memory demands).
     ALLOCATE( buildings(1:num_build) )
 
 !
-!-- Store building IDs and check if building with certain ID is present on
-!-- subdomain. 
+!-- Store building IDs and check if building with certain ID is present on subdomain.
     DO  nb = 1, num_build
        buildings(nb)%id = build_ids_final(nb)
 
-       IF ( ANY( building_id_f%var(nys:nyn,nxl:nxr) == buildings(nb)%id ) )    &
+       IF ( ANY( building_id_f%var(nys:nyn,nxl:nxr) == buildings(nb)%id ) )                        &
           buildings(nb)%on_pe = .TRUE.
-    ENDDO 
-!
-!-- Determine the maximum vertical dimension occupied by each building. 
+    ENDDO
+!
+!-- Determine the maximum vertical dimension occupied by each building.
     ALLOCATE( k_min_l(1:num_build) )
     ALLOCATE( k_max_l(1:num_build) )
     k_min_l = nzt + 1
-    k_max_l = 0    
+    k_max_l = 0
 
     DO  i = nxl, nxr
        DO  j = nys, nyn
           IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
-             nb = MINLOC( ABS( buildings(:)%id - building_id_f%var(j,i) ),    &
-                         DIM = 1 )
+             nb = MINLOC( ABS( buildings(:)%id - building_id_f%var(j,i) ), DIM=1 )
              DO  k = nzb, nzt+1
 !
-!--             Check if grid point belongs to a building. 
+!--             Check if grid point belongs to a building.
                 IF ( BTEST( wall_flags_total_0(k,j,i), 6 ) )  THEN
                    k_min_l(nb) = MIN( k_min_l(nb), k )
@@ -688,9 +703,9 @@
     ENDDO
 
-#if defined( __parallel ) 
-    CALL MPI_ALLREDUCE( k_min_l(:), buildings(:)%kb_min, num_build,            &
-                        MPI_INTEGER, MPI_MIN, comm2d, ierr )
-    CALL MPI_ALLREDUCE( k_max_l(:), buildings(:)%kb_max, num_build,            &
-                        MPI_INTEGER, MPI_MAX, comm2d, ierr )
+#if defined( __parallel )
+    CALL MPI_ALLREDUCE( k_min_l(:), buildings(:)%kb_min, num_build, MPI_INTEGER, MPI_MIN, comm2d,  &
+                        ierr )
+    CALL MPI_ALLREDUCE( k_max_l(:), buildings(:)%kb_max, num_build, MPI_INTEGER, MPI_MAX, comm2d,  &
+                        ierr )
 #else
     buildings(:)%kb_min = k_min_l(:)
@@ -705,6 +720,5 @@
        buildings(nb)%building_height = 0.0_wp
        DO  k = buildings(nb)%kb_min, buildings(nb)%kb_max
-          buildings(nb)%building_height = buildings(nb)%building_height        &
-                                        + dzw(k+1)
+          buildings(nb)%building_height = buildings(nb)%building_height + dzw(k+1)
        ENDDO
     ENDDO
@@ -719,6 +733,5 @@
        volume_l = 0.0_wp
 !
-!--    Calculate building volume per height level on each PE where 
-!--    these building is present. 
+!--    Calculate building volume per height level on each PE where these building is present.
        IF ( buildings(nb)%on_pe )  THEN
 
